/*************************************/
/*                                   */
/*  *** HAPPy Pascal compiler ***    */
/*    identifier routine             */
/*                                   */
/*   Copyright (c) H.Asano 1992      */
/*************************************/

#define  EXTERN  extern

#include <string.h>
#include "pascomp.h"

extern void pcerr(int,char*) ;          /* G[bZ[Wo͏   */
extern int  crelabel(void)   ;
extern void enterstdpf(void) ;          /* W葱֐̓o^*/
extern void term(void) ;                /* I                   */
extern void *Malloc(int) ;              /* mۏ             */


/**************************************/
/*  mkctp() : ctp^̃GAmۂ */
/**************************************/
ctp *mkctp(char *fname,enum idclass fklass,stp *fidtype,ctp *fnext)
{
  ctp *lcp ;

     lcp = (ctp*)Malloc(sizeof(ctp)) ;  /* ctp^GAm          */

     strcpy(lcp->name,fname) ;          /* O̐ݒ                 */
     lcp->idtype = fidtype   ;          /* ^̐ݒ                   */
     lcp->next   = fnext     ;          /* ւ̃N̐ݒ         */
     lcp->klass  = fklass    ;          /* O̎ނ̐ݒ           */

     return(lcp) ;
}

/**************************************/
/*       enterid() :                  */ 
/*         identifier  tree ɓo^  */
/**************************************/

void enterid(ctp *fcp)
{
  ctp     *lcp;
  ctp     *lcp1;
  aplist  *lap ;
  boolean lleft ;       /* Eɓo^邩̃tO lleft=true :  */
  int     cmpresult;                    /* strcmp               */
 
    lap = display[top].aname ;          /* `ɎQƂꂽ   */
    while(lap) {                        /* ׂ                     */
     if(!strcmp(lap->name->name,fcp->name)) {
      pcerr(100,fcp->name) ;            /* 錾ɎQƂꂽ   */
      return;
     }
     lap = lap->next ;
    }

     lcp = display[top].fname;
     if(!lcp) {
      display[top].fname = fcp ;        /* ̐ł̍ŏ̓o^     */
      fcp->llink = nil;
      fcp->rlink = nil;
      return;
     }

     do {
      lcp1 = lcp ;
      if(!(cmpresult=strcmp(lcp->name, fcp->name))){/* ɖO݂鎞 */
       pcerr(101,lcp->name);                   /* O̓d`G[ */
       return ;                                /* o^ɑł؂   */
      }
      else
       if(cmpresult < 0) {                     /* o^閼O傫 */
        lcp = lcp->rlink;                      /* ET             */ 
        lleft = false;
        }
        else {                                 /* o^閼O */
         lcp = lcp->llink;                     /* T             */
         lleft = true ;
        }
     } while (lcp) ;

     if(lleft) lcp1->llink = fcp ;             /* ւ̓o^           */
     else      lcp1->rlink = fcp;              /* Eւ̓o^           */

     fcp->llink = nil;
     fcp->rlink = nil;
}

/*****************************************/
/*   searchsection() :                   */ 
/*    identifier  鐅T */
/*       R[h̖Oꍇ   */
/*       OQƂꂽ葱֐    */
/*****************************************/
ctp *searchsection(ctp *fcp)
{
  int     cmpresult;                    /* strcmp               */
     while(fcp) {
      if(!(cmpresult=strcmp(id,fcp->name)))  /* Ovꍇ    */
       return(fcp) ;
      fcp = (cmpresult > 0) ? fcp->rlink : fcp->llink ;
     }
     return(nil) ;                      /* Ȃꍇ           */
}

/**************************************/
/*       searchid() :                 */ 
/*         identifier  T         */
/**************************************/
ctp *searchid(Set fidcls)
{
  ctp *lcp ;
  boolean error103 = false ;
  int     cmpresult;                    /* strcmp               */

     for(disx=top ; disx>=0 ; disx--) {   /* disx͋ʕϐ            */
                                          /* O*/
      lcp = display[disx].fname ;
      while(lcp) {
       if(!(cmpresult=strcmp(id, lcp->name)))/* Ov         */
        if(inset(fidcls,lcp->klass))      /* v            */
         return(lcp) ;                    /*   ̎lcpԂ       */
        else {                            /* O͈vႤ */  
         pcerr(103,id) ;                  /* O̎ނKłȂ@  */
         error103 = true ;
         break ;                          /* while loop 𔲂       */
        }
       else
        lcp = (cmpresult > 0) ? lcp->rlink : lcp->llink ; 
      }
     }

     /* Ȃlcp=nilłɗ */

     if(! error103) pcerr(104,id) ;     /* 103G[oĂȂ
                                   O錾ĂȂG[o */

     /* |C^^OQƂł͂Ȃ 
          `p̃GAԋp  */
     if(inset(fidcls,types))  return(utypptr) ;   /* type ^̎ */
     if(inset(fidcls,proc ))  return(uprcptr) ;   /* proc ^̎ */
     if(inset(fidcls,vars ))  return(uvarptr) ;   /* var  ^̎ */
     if(inset(fidcls,field))  return(ufldptr) ;   /* field^̎ */
     if(inset(fidcls,konst))  return(ucstptr) ;   /* const^̎ */
     /* LȊO=func */      return(ufctptr) ;   /* func ^̎ */
}

/**************************************/
/* applied() : p`F[     */
/**************************************/
void applied(ctp *fcp,int ftoplevel)
{
  aplist *lap ;
  
     lap = (aplist*)Malloc(sizeof(aplist));
     lap->name = fcp ;
     lap->next = display[ftoplevel].aname ;
     display[ftoplevel].aname = lap ;
}

/***********************************/
/*   entdtdnames() : W̓o^  */
/***********************************/
void entstdnames(void)
{
  ctp *cp;
  ctp *cp1;
  int i;
  char *name;

   /**** interger ****/
     cp = mkctp("integer",types,intptr,nil) ;
     enterid(cp);

   /**** real ****/
     cp = mkctp("real",types,realptr,nil) ;
     enterid(cp);

   /**** char ****/
     cp = mkctp("char",types,charptr,nil) ;
     enterid(cp);

   /**** boolean ****/
     cp = mkctp("boolean",types,boolptr,nil) ;
     enterid(cp);

   /**** text ****/
     cp = mkctp("text",types,textptr,nil) ;
     enterid(cp) ;

  /**** false,true ****/
     cp1 = nil ;
     for(i=0;i<=1;i++) {
      name = (i==0) ? "false" : "true";
      cp = mkctp(name,konst,boolptr,cp1) ;
      cp->n.values.ival = i  ;          /* false=0; true=1            */
      enterid(cp);
      cp1 = cp  ;
     }
     boolptr->sf.sc.fconst = cp ;

   /**** maxint ****/
     cp = mkctp("maxint",konst,intptr,nil) ;
     cp->n.values.ival = Maxint ;       /* ̍ől               */
     enterid(cp) ;

  /**** W葱֐̓o^ ****/
     enterstdpf() ;
}

/**************************************/
/*   entdundecl() :                   */
/*     O`̎̑p̓o^ */
/**************************************/
void entundecl(void)
{
  /**** for types ****/
     utypptr = mkctp(" ",types,nil,nil) ;

  /**** for const ****/
     ucstptr = mkctp(" ",konst,nil,nil) ;
     ucstptr->n.values.ival = 0 ;

  /**** for vars ****/
     uvarptr = mkctp(" ",vars,nil,nil) ;
     uvarptr->n.v.vkind = actual ;
     uvarptr->n.v.vlev  = 0 ;
     uvarptr->n.v.vaddr = 0 ;

  /**** for field ****/
     ufldptr = mkctp(" ",field,nil,nil) ;
     ufldptr->n.fldaddr = 0  ;

  /**** for procedure ****/
     uprcptr = mkctp(" ",proc,nil,nil) ;
     uprcptr->n.pf.pfdeckind          = declared   ;
     uprcptr->n.pf.sd.d.pfkind        = actual     ;
     uprcptr->n.pf.sd.d.pflev         = 0          ;
     uprcptr->n.pf.sd.d.af.a.pfname   = crelabel() ;
     uprcptr->n.pf.sd.d.af.a.forwdecl = false      ;

  /**** for function ****/
     ufctptr = mkctp(" ",func,nil,nil) ;
     ufctptr->n.pf.pfdeckind          = declared   ;
     ufctptr->n.pf.sd.d.pfkind        = actual     ;
     ufctptr->n.pf.sd.d.pflev         = 0          ;
     ufctptr->n.pf.sd.d.af.a.pfname   = crelabel() ;
     ufctptr->n.pf.sd.d.af.a.forwdecl = false      ;
}
